<?xml version="1.0" encoding="UTF-8"?>

<!-- Autor: Roland Dreger, www.rolanddreger.net -->
<!-- Creation Date: 6. Maerz 2016 -->
<!-- Last Changes: 12. Maerz 2016 -->

<!-- Creative Commons Licence: Roland Dreger, CC BY SA 3.0 AT -->

<!-- Trasforms XML Calendar to InDesign -->

<!DOCTYPE transform [
	<!ENTITY paragraphBreak "&#x0d;">
	<!ENTITY flushSpace "&#x2001;">
]>

<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 						 
	xmlns:aid="http://ns.adobe.com/AdobeInDesign/4.0/"
	xmlns:aid5="http://ns.adobe.com/AdobeInDesign/5.0/" 
	version="1.0">
	
	<xsl:template match="/">
		<Root>
			<Jahr>
				<xsl:copy-of select="@*" />
				<Jahreszahl>
					<xsl:attribute name="aid:pstyle">Jahreszahl</xsl:attribute>
					<xsl:value-of select="year/date" />
				</Jahreszahl>
				<xsl:text>&paragraphBreak;</xsl:text>
				<xsl:apply-templates select="year/month" />
				<xsl:call-template name="holidays" />
			</Jahr>
		</Root>
	</xsl:template>
	
	<xsl:template match="month">
		<xsl:variable name="columnWidth">22</xsl:variable>
		<Monat>
			<Monatstabelle>
				<xsl:copy-of select="@*" />
				<xsl:attribute name="aid:table">table</xsl:attribute>
				<xsl:attribute name="aid:trows">8</xsl:attribute>
				<xsl:attribute name="aid:tcols">7</xsl:attribute>
				<xsl:attribute name="aid5:tablestyle">Monatstabelle</xsl:attribute>
				<Name>
					<xsl:attribute name="aid:table">cell</xsl:attribute>
					<xsl:attribute name="aid:theader" />
					<xsl:attribute name="aid:crows">1</xsl:attribute>
					<xsl:attribute name="aid:ccols">7</xsl:attribute>
					<xsl:attribute name="aid5:cellstyle">Zelle-Monatsname</xsl:attribute>
					<xsl:attribute name="aid:pstyle">Monatsname</xsl:attribute>
					<xsl:value-of select="name" />
				</Name>
				<Wochentag>
					<xsl:attribute name="aid:table">cell</xsl:attribute>
					<xsl:attribute name="aid:crows">1</xsl:attribute>
					<xsl:attribute name="aid:ccols">1</xsl:attribute>
					<xsl:attribute name="aid5:cellstyle">Zelle-Wochentag-Label</xsl:attribute>
					<xsl:attribute name="aid:pstyle">Wochentag-Label</xsl:attribute>
					<xsl:attribute name="aid:ccolwidth"><xsl:value-of select="$columnWidth"/></xsl:attribute>
					<xsl:text>Mo</xsl:text>
				</Wochentag>
				<Wochentag>
					<xsl:attribute name="aid:table">cell</xsl:attribute>
					<xsl:attribute name="aid:crows">1</xsl:attribute>
					<xsl:attribute name="aid:ccols">1</xsl:attribute>
					<xsl:attribute name="aid5:cellstyle">Zelle-Wochentag-Label</xsl:attribute>
					<xsl:attribute name="aid:pstyle">Wochentag-Label</xsl:attribute>
					<xsl:attribute name="aid:ccolwidth"><xsl:value-of select="$columnWidth"/></xsl:attribute>
					<xsl:text>Di</xsl:text>
				</Wochentag>
				<Wochentag>
					<xsl:attribute name="aid:table">cell</xsl:attribute>
					<xsl:attribute name="aid:crows">1</xsl:attribute>
					<xsl:attribute name="aid:ccols">1</xsl:attribute>
					<xsl:attribute name="aid5:cellstyle">Zelle-Wochentag-Label</xsl:attribute>
					<xsl:attribute name="aid:pstyle">Wochentag-Label</xsl:attribute>
					<xsl:attribute name="aid:ccolwidth"><xsl:value-of select="$columnWidth"/></xsl:attribute>
					<xsl:text>Mi</xsl:text>
				</Wochentag>
				<Wochentag>
					<xsl:attribute name="aid:table">cell</xsl:attribute>
					<xsl:attribute name="aid:crows">1</xsl:attribute>
					<xsl:attribute name="aid:ccols">1</xsl:attribute>
					<xsl:attribute name="aid5:cellstyle">Zelle-Wochentag-Label</xsl:attribute>
					<xsl:attribute name="aid:pstyle">Wochentag-Label</xsl:attribute>
					<xsl:attribute name="aid:ccolwidth"><xsl:value-of select="$columnWidth"/></xsl:attribute>
					<xsl:text>Do</xsl:text>
				</Wochentag>
				<Wochentag>
					<xsl:attribute name="aid:table">cell</xsl:attribute>
					<xsl:attribute name="aid:crows">1</xsl:attribute>
					<xsl:attribute name="aid:ccols">1</xsl:attribute>
					<xsl:attribute name="aid5:cellstyle">Zelle-Wochentag-Label</xsl:attribute>
					<xsl:attribute name="aid:pstyle">Wochentag-Label</xsl:attribute>
					<xsl:attribute name="aid:ccolwidth"><xsl:value-of select="$columnWidth"/></xsl:attribute>
					<xsl:text>Fr</xsl:text>
				</Wochentag>
				<Wochentag>
					<xsl:attribute name="aid:table">cell</xsl:attribute>
					<xsl:attribute name="aid:crows">1</xsl:attribute>
					<xsl:attribute name="aid:ccols">1</xsl:attribute>
					<xsl:attribute name="aid5:cellstyle">Zelle-Wochentag-Label</xsl:attribute>
					<xsl:attribute name="aid:pstyle">Wochentag-Label</xsl:attribute>
					<xsl:attribute name="aid:ccolwidth"><xsl:value-of select="$columnWidth"/></xsl:attribute>
					<xsl:text>Sa</xsl:text>
				</Wochentag>
				<Wochentag>	
					<xsl:attribute name="aid:table">cell</xsl:attribute>
					<xsl:attribute name="aid:crows">1</xsl:attribute>
					<xsl:attribute name="aid:ccols">1</xsl:attribute>
					<xsl:attribute name="aid5:cellstyle">Zelle-Wochentag-Label</xsl:attribute>
					<xsl:attribute name="aid:pstyle">Wochentag-Label</xsl:attribute>
					<xsl:attribute name="aid:ccolwidth"><xsl:value-of select="$columnWidth"/></xsl:attribute>
					<xsl:text>So</xsl:text>
				</Wochentag>		
				<xsl:choose>
					<xsl:when test="day[1]/@weekday = 'Montag'">
						<xsl:apply-templates select="day" />
						<xsl:call-template name="daysOfNextMonth" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="daysOfPrevMonth" />
						<xsl:apply-templates select="day" />
						<xsl:call-template name="daysOfNextMonth" />
					</xsl:otherwise>
				</xsl:choose>
			</Monatstabelle>
		</Monat>
		<xsl:text>&paragraphBreak;</xsl:text>
	</xsl:template>
	
	<xsl:template name="daysOfPrevMonth">
		<xsl:choose>
			<xsl:when test="day[1]/@weekday = 'Dienstag'">
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">31</xsl:if> <!-- Wert fuer Dezember des Vorjahres -->
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/self::day" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="day[1]/@weekday = 'Mittwoch'">
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">30</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/preceding-sibling::day[1]" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">31</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/self::day" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="day[1]/@weekday = 'Donnerstag'">
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">29</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/preceding-sibling::day[2]" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">30</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/preceding-sibling::day[1]" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">31</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/self::day" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="day[1]/@weekday = 'Freitag'">
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">28</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/preceding-sibling::day[3]" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">29</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/preceding-sibling::day[2]" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">30</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/preceding-sibling::day[1]" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">31</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/self::day" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="day[1]/@weekday = 'Samstag'">
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">27</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/preceding-sibling::day[4]" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">28</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/preceding-sibling::day[3]" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">29</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/preceding-sibling::day[2]" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">30</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/preceding-sibling::day[1]" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">31</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/self::day" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="day[1]/@weekday = 'Sonntag'">
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">26</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/preceding-sibling::day[5]" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">27</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/preceding-sibling::day[4]" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">28</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/preceding-sibling::day[3]" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">29</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/preceding-sibling::day[2]" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">30</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/preceding-sibling::day[1]" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				<xsl:call-template name="dayOfPrevMonth">
					<xsl:with-param name="day">
						<xsl:if test="position() = 1">31</xsl:if>
						<xsl:if test="position() != 1">
							<xsl:value-of select="preceding-sibling::month[1]/day[position() = last()]/self::day" />
						</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="dayOfPrevMonth">
		<xsl:param name="day" />
		<Tag>
			<xsl:attribute name="aid:table">cell</xsl:attribute>
			<xsl:attribute name="aid:crows">1</xsl:attribute>
			<xsl:attribute name="aid:ccols">1</xsl:attribute>
			<xsl:attribute name="aid5:cellstyle">Zelle-Wochentag-Zahl (vorangehendes Monat)</xsl:attribute>
			<xsl:attribute name="aid:pstyle">Wochentag-Zahl (vorangehendes Monat)</xsl:attribute>
			<xsl:value-of select="$day" />
		</Tag>	
	</xsl:template>
	
	<xsl:template match="day">
		<Tag>
			<xsl:copy-of select="@*" />
			<xsl:attribute name="aid:table">cell</xsl:attribute>
			<xsl:attribute name="aid:crows">1</xsl:attribute>
			<xsl:attribute name="aid:ccols">1</xsl:attribute>
			<xsl:attribute name="aid5:cellstyle">Zelle-Wochentag-Zahl</xsl:attribute>	
			<xsl:choose>
				<xsl:when test="boolean(@holiday)">
					<xsl:attribute name="aid:pstyle">Feiertag-Zahl</xsl:attribute>
				</xsl:when>
				<xsl:when test="(@weekday = 'Samstag') or (@weekday = 'Sonntag')">
					<xsl:attribute name="aid:pstyle">Wochenende-Zahl</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="aid:pstyle">Wochentag-Zahl</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:value-of select="." />
		</Tag>	
	</xsl:template>
	
	<xsl:template name="daysOfNextMonth">
		<xsl:call-template name="dayOfNextMonth">
			<xsl:with-param name="day">1</xsl:with-param>
		</xsl:call-template>
		<xsl:call-template name="dayOfNextMonth">
			<xsl:with-param name="day">2</xsl:with-param>
		</xsl:call-template>
		<xsl:call-template name="dayOfNextMonth">
			<xsl:with-param name="day">3</xsl:with-param>
		</xsl:call-template>
		<xsl:call-template name="dayOfNextMonth">
			<xsl:with-param name="day">4</xsl:with-param>
		</xsl:call-template>
		<xsl:call-template name="dayOfNextMonth">
			<xsl:with-param name="day">5</xsl:with-param>
		</xsl:call-template>
		<xsl:call-template name="dayOfNextMonth">
			<xsl:with-param name="day">6</xsl:with-param>
		</xsl:call-template>
		<xsl:call-template name="emptyCell" />
		<xsl:call-template name="emptyCell" />
		<xsl:call-template name="emptyCell" />
		<xsl:call-template name="emptyCell" />
		<xsl:call-template name="emptyCell" />
		<xsl:call-template name="emptyCell" />
		<xsl:call-template name="emptyCell" />
	</xsl:template>
	
	<xsl:template name="dayOfNextMonth">
		<xsl:param name="day" />
		<xsl:variable name="dayShift1">
			<xsl:choose>
				<xsl:when test="day[1]/@weekday = 'Montag'">0</xsl:when>
				<xsl:when test="day[1]/@weekday = 'Dienstag'">1</xsl:when>
				<xsl:when test="day[1]/@weekday = 'Mittwoch'">2</xsl:when>
				<xsl:when test="day[1]/@weekday = 'Donnerstag'">3</xsl:when>
				<xsl:when test="day[1]/@weekday = 'Freitag'">4</xsl:when>
				<xsl:when test="day[1]/@weekday = 'Samstag'">5</xsl:when>
				<xsl:when test="day[1]/@weekday = 'Sonntag'">6</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="numOfDays1">
			<xsl:value-of select="count(day)" />
		</xsl:variable>
		<xsl:variable name="numOfRows1">
			<xsl:choose>
				<xsl:when test="$numOfDays1 + $dayShift1 &lt; 29">
					<xsl:text>7</xsl:text>
				</xsl:when>
				<xsl:when test="($numOfDays1 + $dayShift1 &gt; 28) and ($numOfDays1 + $dayShift1 &lt; 36)">
					<xsl:text>8</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>9</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="(($dayShift1 + $numOfDays1 + $day &lt; 36) and ($numOfRows1 = 8)) or (($dayShift1 + $numOfDays1 + $day &lt; 43) and ($numOfRows1 = 9))">
			<Tag>
				<xsl:attribute name="aid:table">cell</xsl:attribute>
				<xsl:attribute name="aid:crows">1</xsl:attribute>
				<xsl:attribute name="aid:ccols">1</xsl:attribute>
				<xsl:attribute name="aid5:cellstyle">Zelle-Wochentag-Zahl (nächstes Monat)</xsl:attribute>
				<xsl:attribute name="aid:pstyle">Wochentag-Zahl (nächstes Monat)</xsl:attribute>
				<xsl:value-of select="$day" />
			</Tag>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="emptyCell">
		<xsl:variable name="dayShift2">
			<xsl:choose>
				<xsl:when test="day[1]/@weekday = 'Montag'">0</xsl:when>
				<xsl:when test="day[1]/@weekday = 'Dienstag'">1</xsl:when>
				<xsl:when test="day[1]/@weekday = 'Mittwoch'">2</xsl:when>
				<xsl:when test="day[1]/@weekday = 'Donnerstag'">3</xsl:when>
				<xsl:when test="day[1]/@weekday = 'Freitag'">4</xsl:when>
				<xsl:when test="day[1]/@weekday = 'Samstag'">5</xsl:when>
				<xsl:when test="day[1]/@weekday = 'Sonntag'">6</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="numOfDays2">
			<xsl:value-of select="count(day)" />
		</xsl:variable>
		<xsl:if test="$numOfDays2 + $dayShift2 &lt; 29">
			<Tag>
				<xsl:attribute name="aid:table">cell</xsl:attribute>
				<xsl:attribute name="aid:crows">1</xsl:attribute>
				<xsl:attribute name="aid:ccols">1</xsl:attribute>
				<xsl:attribute name="aid5:cellstyle">Zelle-Leer</xsl:attribute>
				<xsl:attribute name="aid:pstyle">Leere Zelle </xsl:attribute>
				<xsl:text></xsl:text>
			</Tag>
		</xsl:if>
		<xsl:if test="$numOfDays2 + $dayShift2 &lt; 36">
			<Tag>
				<xsl:attribute name="aid:table">cell</xsl:attribute>
				<xsl:attribute name="aid:crows">1</xsl:attribute>
				<xsl:attribute name="aid:ccols">1</xsl:attribute>
				<xsl:attribute name="aid5:cellstyle">Zelle-Leer</xsl:attribute>
				<xsl:attribute name="aid:pstyle">Leere Zelle</xsl:attribute>
				<xsl:text></xsl:text>
			</Tag>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="holidays">
		<xsl:variable name="lastHoliday">
			<xsl:value-of select="/year/month[12]/day[@holiday][last()]/@holiday" />
		</xsl:variable>
		<Feiertage>
			<xsl:attribute name="aid:pstyle">Feiertage</xsl:attribute>
			<xsl:for-each select="year/month">
				<xsl:variable name="monat">
					<xsl:value-of select="position()" />
				</xsl:variable>
				<xsl:for-each select="day/@holiday">
					<Eintrag>
						<xsl:attribute name="aid:cstyle">Feiertagseintrag</xsl:attribute>
						<Tag>
							<xsl:value-of select=".." /><xsl:text>.&#xa0;</xsl:text>
						</Tag>
						<Monat>
							<xsl:value-of select="$monat" /><xsl:text>.&#xa0;</xsl:text>
						</Monat>
						<Name>
							<xsl:value-of select="." />
						</Name>
					</Eintrag>
					<xsl:if test="$lastHoliday != .">
						<xsl:element name="Separator">
							<xsl:attribute name="aid:cstyle">Trenner</xsl:attribute>
							<xsl:text> &#x2014; </xsl:text>
						</xsl:element>
					</xsl:if>
				</xsl:for-each>
			</xsl:for-each>
		</Feiertage>
	</xsl:template>
	
</xsl:transform>